@ECHO OFF
SETLOCAL

REM ************************************************************************************
REM **  Author:   Thornberry Ltd., Copyright 2011                                     **
REM **  Purpose:  Shut down all instances of Cache and/or Ensemble database software  **
REM ************************************************************************************


REM Look up the processor architecture
FOR /F "tokens=2*" %%A IN ('REG QUERY "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager\Environment" /v PROCESSOR_ARCHITECTURE') DO (
    SET ProcArch=%%B
)

REM Get appropriate registry path based on architecture
IF "%ProcArch%" == "x86" (
    SET RegPath=HKEY_LOCAL_MACHINE\SOFTWARE\InterSystems\Cache\Configurations
    SET Tokens1=tokens=5*
) ELSE (
    SET RegPath=HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\InterSystems\Cache\Configurations
    SET Tokens1=tokens=6*
)

REM Look up the version of Windows
FOR /F "tokens=2*" %%A IN ('REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v CurrentVersion') DO (
    SET OsVersion=%%B
)

SET Skip1=
SET Skip2=
SET Tokens2=tokens=2*
IF "%OsVersion%" == "6.3" (
	REM Windows 10 OR Windows 8.1 OR Server 2012R2
) ELSE IF "%OsVersion%" == "6.2" (
	REM Windows 8 or Server 2012
) ELSE IF "%OsVersion%" == "6.1" (
    REM Windows 7 OR Server 2008 R2
) ELSE IF "%OsVersion%" == "6.0" (
    REM Windows Vista OR Server 2008
) ELSE IF "%OsVersion%" == "5.2" (
    REM Windows XP x64 OR Server 2003 OR Server 2003 R2 OR Home Server
) ELSE IF "%OsVersion%" == "5.1" (
    REM Windows XP
    SET Skip1= skip=5
    SET Skip2= skip=2
    SET Tokens2=tokens=3*
) ELSE (
    ECHO Unable to determine operating system
    GOTO END
)

REM Cycle through Cache instances and shut them down
FOR /F "%Tokens1%%Skip1% delims=\" %%A IN ('REG QUERY %RegPath%') DO (
	FOR /F "%Tokens2%%Skip2%" %%C IN ('2^>NUL REG QUERY %RegPath%\%%B\Directory /ve') DO (
		ECHO Shutting down %%B instance
		START /wait %%D\bin\css stop %%B
	)
)